require 'roundhouse'

module Roundhouse
  module ExceptionHandler

    class Logger
      def call(ex, ctxHash)
        Roundhouse.logger.warn(ctxHash) if !ctxHash.empty?
        Roundhouse.logger.warn "#{ex.class.name}: #{ex.message}"
        Roundhouse.logger.warn ex.backtrace.join("\n") unless ex.backtrace.nil?
      end

      # Set up default handler which just logs the error
      Roundhouse.error_handlers << Roundhouse::ExceptionHandler::Logger.new
    end

    def handle_exception(ex, ctxHash={})
      Roundhouse.error_handlers.each do |handler|
        begin
          handler.call(ex, ctxHash)
        rescue => ex
          Roundhouse.logger.error "!!! ERROR HANDLER THREW AN ERROR !!!"
          Roundhouse.logger.error ex
          Roundhouse.logger.error ex.backtrace.join("\n") unless ex.backtrace.nil?
        end
      end
    end

  end
end
